Package org.apache.commons.math3.ode

# Interface FieldSecondaryEquations<T extends RealFieldElement<T>>

Type Parameters:
  `T` - the type of the field elements

public interface FieldSecondaryEquations<T extends RealFieldElement<T>>
This interface allows users to add secondary differential equations to a primary set of differential equations.

In some cases users may need to integrate some problem-specific equations along with a primary set of differential equations. One example is optimal control where adjoined parameters linked to the minimized Hamiltonian must be integrated.

This interface allows users to add such equations to a primary set of `first order differential equations` thanks to the `FieldExpandableODE.addSecondaryEquations(FieldSecondaryEquations)` method.

Since:
  3.6
See Also:
  - `FirstOrderFieldDifferentialEquations`
  - `FieldExpandableODE`

## Method Summary

Modifier and Type
Method
Description
`T[]`
`computeDerivatives(T t, T[] primary, T[] primaryDot, T[] secondary)`
Compute the derivatives related to the secondary state parameters.
`int`
`getDimension()`
Get the dimension of the secondary state parameters.
`void`
`init(T t0, T[] primary0, T[] secondary0, T finalTime)`
Initialize equations at the start of an ODE integration.

## Method Details

### getDimension

int getDimension()
Get the dimension of the secondary state parameters.

Returns:
  dimension of the secondary state parameters

### init

void init(T t0, T[] primary0, T[] secondary0, T finalTime)
Initialize equations at the start of an ODE integration.

This method is called once at the start of the integration. It may be used by the equations to initialize some internal data if needed.

Parameters:
  `t0` - value of the independent time variable at integration start
  `primary0` - array containing the value of the primary state vector at integration start
  `secondary0` - array containing the value of the secondary state vector at integration start
  `finalTime` - target time for the integration

### computeDerivatives

T[] computeDerivatives(T t, T[] primary, T[] primaryDot, T[] secondary) throws MaxCountExceededException, DimensionMismatchException
Compute the derivatives related to the secondary state parameters.

Parameters:
  `t` - current value of the independent time variable
  `primary` - array containing the current value of the primary state vector
  `primaryDot` - array containing the derivative of the primary state vector
  `secondary` - array containing the current value of the secondary state vector
Returns:
  derivative of the secondary state vector
Throws:
  `MaxCountExceededException` - if the number of functions evaluations is exceeded
  `DimensionMismatchException` - if arrays dimensions do not match equations settings